#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <sstream>
#include <algorithm>
#include <map>
#include <vector>
#include <ctype.h>
#include <queue>
#include <string>

using namespace std;

struct state{
    string s;
    int r;
    state(string s, int r):s(s),r(r){}
};

int N;
int pode;
int pp[11],u;

int read(){
    if( scanf("%d",&N) != 1 ) return 0;    
    int k;
    scanf("%d",&k);
    pode = 0;
    u = 0;
    while(k--){
        int p;
        scanf("%d",&p);
        if(! ((pode>>p)&1)){
            pp[u++] = p;
        }
        pode |= (1<<p);
    }
    sort(pp,pp+u);
    
    return 1;
}

char mark[5100];

void process(){

    memset(mark,0,sizeof(mark));
    int i,j,k;
    queue < state > pq;
    
    if( N == 0 ){
        printf("0\n");
        return ;
    }
    
    for(i=0;i<u;i++){
        if( pp[i] ){
            if( pp[i]%N == 0 && !mark[pp[i]%N] ){
                printf("%d\n",pp[i]);
                return;
            }
            
            string T = "";
            T = pp[i]+'0';
            pq.push(state(T,pp[i]%N));
        }
    }
        
    while( !pq.empty() ){
        state top = pq.front();
        pq.pop();
        
        if( top.r == 0 ){
            printf("%s\n",top.s.c_str());
            return ;
        }
        
        if(mark[top.r]) continue;
        mark[top.r] = 1;
        
        int i;
        for(i=0;i<u;i++){
            if( !mark[ (top.r*10 + pp[i])%N ] ){
                string T = top.s;
                T += pp[i]+'0';
                pq.push( state(T,(top.r*10 + pp[i])%N) );
            }
        }
    }
    
    printf("0\n"); 
}

int main(){
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);

    int i,j;

    while(read()){
        process();
    }
    return 0;
}
