#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>
#include <queue>
#include <string>

using namespace std;


int grafo[600][1000];
int numadj[600];
int n;

int cap[600][600];

int read(){
    if(scanf("%d",&n)!=1 ) return 0;
    
    int i;
    memset(numadj,0,sizeof(numadj));
        

    int tam,no,j,viz;
    
    for(i=0;i<n;i++){
        scanf("%d: (%d)",&no,&tam);
        for(j=0;j<tam;j++){
            scanf("%d",&viz);

            grafo[no][numadj[no]++] = viz;
        }
    }
    
    return 1;
}

char mark[1000];

int dfs(int no){
    if(no == n)return 1;
    mark[no] = 1;
   
   for(int i = 0; i < numadj[no];i++){
		if(!mark[grafo[no][i]] && cap[no][grafo[no][i]] > 0){
			if(dfs(grafo[no][i])){
				cap[no][grafo[no][i]] = 0;
				cap[grafo[no][i]][no] = 1;
				return 1;
			}
		}
	}
   
   return 0;
}

int vis[600];

void dfs(int no,int cor){
    vis[no] = cor;
    int i;
    for(i=0;i<numadj[no];i++){
        if( vis[ grafo[no][i] ] == -1 ){
            dfs(grafo[no][i],1-cor);
        }else if(vis[grafo[no][i]] == vis[no]){
			printf("cacete\n");
		}
    }
}

void process(){
    int total = 0;
    int i,j;
    memset(vis,-1,sizeof(vis));
    for(i=0;i<n;i++){
        if( vis[i] < 0 ){
            dfs(i,0);
        }

    }
    
    memset(cap,0,sizeof(cap));
    int di = n;
    for(i=0;i<n;i++){
		//if(numadj[i] != 0)
	//		di++;
        if( vis[i] == 0 ){
            
            for(j=0;j<numadj[i];j++){
                cap[i][grafo[i][j]] = 1;

            }
            
            // n+1 - source
            cap[n+1][i] = 1;
            grafo[n+1][numadj[n+1]++] = i;
            grafo[i][numadj[i]++] = n+1;
        }
        else{
            // n - sink

            cap[i][n] = 1;
            grafo[n][numadj[n]++] = i;
            grafo[i][numadj[i]++] = n;
        }
    }
    
    int k,flow=0;
   		 memset(mark, 0, sizeof(mark));
    while(dfs(n+1)){
		 memset(mark, 0, sizeof(mark));
		 flow++;
	}
    printf("%d\n",di-flow);

}

int main(){
    freopen("d.in","r", stdin);
    freopen("d2.out","w", stdout);
    while(read()){
        process();
    }
    return 0;
}
