#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>

using namespace std;

int grafo[1000][1000];
int numadj[1000];

int LV[1000];
int pai[1000][30];

int ret[1000];

int n,raiz;

int read(){
    if(scanf("%d",&n)!=1 ) return 0;
    
    int i;
    memset(numadj,0,sizeof(numadj));
    
    int tam,no,j,viz;
    char t;
    
    memset(pai,-1,sizeof(pai));
    raiz = -1;
    
    for(i=0;i<n;i++){
        scanf("%d",&no);
        if( raiz == -1 ) raiz = no;
        scanf("%c",&t);
        while( t != '(' ) scanf("%c",&t);
        scanf("%d",&tam);
        scanf("%c",&t);
        while( t != ')' ) scanf("%c",&t);
        for(j=0;j<tam;j++){
            scanf("%d",&viz);
            grafo[no][numadj[no]++] = viz;
            pai[viz][0] = no;
        }
    }
    
    return 1;
}

void make(){
    int i,j;
    for(j=1;j<16;j++){
        for(i=1;i<=n;i++){
            if( pai[i][j-1] != -1 ){
                if( pai[ pai[i][j-1] ][ j-1 ] != -1 ){
                    pai[i][j] = pai[ pai[i][j-1] ][ j-1 ];
                }
            }
        }
    }
}

char mark[1000];
void dfs(int no,int level){
    mark[no] = 1;
    LV[no] = level;
    int i;
    for(i=0;i<numadj[no];i++){
        if( !mark[ grafo[no][i] ]  ){
            dfs(grafo[no][i],level+1);
        }
    }
}

int find(int no1,int no2){
    if( no1 == no2 ) return no1;
    
    if( LV[no1] > LV[no2] ) swap(no1,no2);
    
    int i,j;
    for(j=15;j>=0;j--){
        if( pai[no2][j] != -1 ){
            if( LV[ pai[no2][j] ] >= LV[no1] ){
                no2 = pai[no2][j];
            }
        }
    }
    
    if( no1 == no2 ) return no1;
    
    for(j=15;j>=0;j--){
        if(  pai[no1][j] != -1 && pai[no1][j] != pai[no2][j] ){
            no1 = pai[no1][j];
            no2 = pai[no2][j];
        }
    }
    
    if( no1 == no2 ) return no1;  
    return pai[no1][0];
}

void process(){
    
    memset(ret,0,sizeof(ret));
    make();
    memset(mark,0,sizeof(mark));
    
    dfs(raiz,0);
    
    int q;
    scanf("%d",&q);
    
    int i,j,a,b;
    char t;
    
    for(i=0;i<q;i++){
        scanf("%c",&t);
        while( t != '(' ) scanf("%c",&t);
        scanf("%d %d",&a,&b);
        
        int p = find(a,b);
        ret[ p ]++;
        scanf("%c",&t);
        while( t != ')' ) scanf("%c",&t);
    }
    
    for(i=1;i<=n;i++){
        if( ret[i] ) printf("%d:%d\n",i,ret[i]);
    }
}

int main(){
    
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);
    while(read()) process();
    return 0;
}
