#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <sstream>
#include <algorithm>
#include <map>
#include <vector>
#include <ctype.h>

using namespace std;

int n;
pair < pair< int , int > , pair < int , int > > pos[1000];

int inc[4][2] = { {-1,0},{0,-1},{1,0},{0,1} } ;
int caso;

int read(){
    scanf("%d",&n);
    
    int i;
    int a,b;
    char t[10];
    
    for(i=0;i<n;i++){
        scanf("%d, %d, %s",&a,&b,t);
        pos[i].first = make_pair(a,b);
        pos[i].second.first = (t[0]=='F')?1:0;
        pos[i].second.second = -1;
    }
    
    return 1;
}

int ver(){
    int i;
    for(i=0;i<n;i++){
        if( pos[0].first != pos[i].first ) return 0;
    }
    return 1;
}

void move(){
    int i;
    for(i=0;i<n;i++){
        int dir = pos[i].second.first;
        
        int x = pos[i].first.first;
        int y = pos[i].first.second;
        
        int nx = x + inc[dir][0];
        int ny = y + inc[dir][1];
        
        if( nx > 0 && nx < 5 && ny > 0 && ny < 5 ){
            pos[i].second.second = x*10+y;
            pos[i].second.first = dir;
            pos[i].first = make_pair(nx,ny);
        }
        else{
            
            dir = (dir + 1)%4;
            nx = x + inc[dir][0];
            ny = y + inc[dir][1];
    
            if( nx > 0 && nx < 5 && ny > 0 && ny < 5 ){
                pos[i].second.second = x*10+y;
                pos[i].second.first = dir;
                pos[i].first = make_pair(nx,ny);
            }
            else{
                
                dir = (dir + 1)%4;
                             
                if( pos[i].second.second > 0 ){
                    pos[i].second.second = x*10+y;
                    pos[i].second.first = dir;
                    
                    nx = x + inc[dir][0];
                    ny = y + inc[dir][1];
                    pos[i].first = make_pair(nx,ny);
                }
            }
        }
    }
}

void process(){
    
    int i,j,t=0;
    
    printf("Case %d: ",caso++);
    if( n == 0 ){
        printf("no terror threat\n");
        return ;
    }
    
    while(t<1440){
        if( ver() ){
            printf("%d, %d, %d%02d\n",pos[0].first.second,pos[0].first.first, (8+t/60)%24 , t%60 );
            return ;
        }
        move();
        t+=20;
    }
    if( ver() ){
        printf("%d, %d, %d%02d\n",pos[0].first.second,pos[0].first.first, (8+t/60)%24 , t%60 );
        return ;
    }
        
    printf("no terror threat\n");
}

int main(){
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);
    int casos;
    scanf("%d",&casos);
    caso = 1;
    while(casos--){
        read();
        process();
    }
    return 0;
}
