#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>

using namespace std;

char m[400][400];
int cont[400][400];

int r,c,k;

int read(){
    scanf("%d %d %d",&r,&c,&k);
    if( k+r+c == 0 ) return 0;
    
    int i,j;
    for(i=0;i<r;i++){
        scanf("%s",m[i]);
        for(j=0;j<c;j++){
            if( j == 0 ){
                if( m[i][j] == '.' ) cont[i][j] = 1;
                else cont[i][j] = 0;
            }
            else{
                cont[i][j] = cont[i][j-1];
                if( m[i][j] == '.' ) cont[i][j]++;
            }
        }
    }
    
    return 1; 
}


void process(){
    int best = r*c;
    
    int i,j,v;
    int ini,fim;
    
    for(i=0;i<c;i++){
        for(j=i;j<c;j++){
            
            if( best == k ){
                printf("%d\n",best);
                return ;
            }
            
            ini = fim = 0;
            int atual = cont[0][j];
            if( i > 0 ) atual -= cont[0][i-1];
            
            int area = j-i+1;
            
            while( ini < r ){
                                
                if( atual < k ){
                                        
                    if( fim < r-1 ){
                        area += j-i+1;
                        fim++;
                        atual += cont[fim][j];
                        if( i > 0 ) atual -= cont[fim][i-1];
                    }
                    else{
                        break;
                    }
                }
                else{
                    if( area < best ) best = area;
                    
                    if( ini < fim ) {
                        atual -= cont[ini][j];
                        if( i > 0 ) atual += cont[ini][i-1];
                        ini++;
                        area -= j-i+1;
                    }
                    else{
                        if( fim < r - 1 ){
                            fim++;
                            area += j-i+1;
                            atual += cont[fim][j];
                            if( i > 0 ) atual -= cont[fim][i-1];
                            
                        }
                        else break;
                    }
                }                   
            }
        }
    }
    
    printf("%d\n",best);
}

int main(){
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);
    
    while(read())process();
    return 0;
}
