#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <vector>

using namespace std;

struct state{
    int xf,xs;
    int yf,ys;
};
state in[10000];

int n;

int read(){
    
    if( scanf("%d",&n) != 1 ) return 0;
    int i;
    for(i=0;i<n;i++){
        scanf("%d %d %d %d",&in[i].xf,&in[i].xs,&in[i].yf,&in[i].ys);
    }
    return 1;
}

int comp(const void *a, const void *b){
    state a1 = *(state *)a;
    state a2 = *(state *)b;
    if( a1.xf == a2.xf ) return a1.xs - a2.xs;
    return a1.xf - a2.xf;
}

void process(){
    int ret=0;
    int i,j;
    qsort(in,n,sizeof(in[0]),comp);
    
    for(i=0;i<n;i++){
        for(j=0;j<n && in[j].xf <= in[i].xf ;j++){
            if( i == j )  continue;
            if( in[j].xs >= in[i].xs &&
                in[j].yf <= in[i].yf && in[j].ys >= in[i].ys ){
                    ret++;
                    break;
                }
        }
    }
    printf("%d\n",ret);
}

int main(){
    
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);
    while(read()) process();
    return 0;
}
