#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <sstream>
#include <algorithm>

using namespace std;

struct state{
    int x,y;
    int p;
};

state ar[10000],saida[10000];
int nar;

int n;
int s;

int comp(const void *a, const void *b){
    state a1 = *(state *)a;
    state a2 = *(state *)b;
    if( a1.p == a2.p ){
        if( a1.x == a2.x ) return a1.y - a2.y;
        return a1.x - a2.x;
    }
    return a1.p - a2.p;
}

int pai[100000];
int caso;

int find(int no){
    if(no != pai[no]) return pai[no] = find(pai[no]);
    return no;
}

int uniao(int a,int b){
    int p1 = find(a);
    int p2 = find(b);
    if( p1 != p2 ){
        pai[p1] = p2;
        return 1;
    }
    return 0;
}

int read(){
    scanf("%d",&n);
    int i,j;
    nar = 0;
    
    for(i=0;i<n;i++){
        for(j=0;j<n;j++){
            int k;
            scanf("%d,",&k);
            if( i < j && k ){
                ar[nar].x = i;
                ar[nar].y = j;
                ar[nar].p = k;
                nar++;
            }
        }    
    }
    return 1;
}

void process(){

    qsort(ar,nar,sizeof(ar[0]),comp);
    
    int tam = 0,i;
    for(i=0;i<n;i++) pai[i] = i;
    
    s = 0;
    i = 0;
    printf("Case %d:\n",caso++);
    
    while(i < nar && tam < n-1){
        state atual = ar[i];
        if( uniao(ar[i].x,ar[i].y) ){
            //saida[tam] = ar[i];
            printf("%c-%c %d\n",ar[i].x+'A',ar[i].y+'A',ar[i].p);
            tam++;
        }
        i++;
    }
}

int main(){
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);
    int casos;
    scanf("%d",&casos);
    caso = 1;
    while(casos--){
        read();
        process();
    }
    return 0;
}
