#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <ctype.h>

using namespace std;

char p1[10],p2[10];
int C;

int val[30];
long long OLDL;

int read(){
    scanf("%s %s %d",p1,p2,&C);
    if( p1[0] == '*' && p2[0] == '*' && C == 0 ) return 0;
    
    return 1; 
}

int valid(char *s){
    int i;
    if( strlen(s) != 7 ) return 0;
    
    if( isupper(s[0]) && isupper(s[1]) && isupper(s[2]) &&
        isdigit(s[3]) && isdigit(s[4]) && isdigit(s[5]) && isdigit(s[6]) ) return 1;
        
    if( isupper(s[0]) && isupper(s[1]) && isupper(s[2]) && isupper(s[3]) && isupper(s[4])  &&
        isdigit(s[5]) && isdigit(s[6]) ){
        
        for(i=0;i<5;i++)
            if( s[i] == 'A' || s[i] == 'C' || s[i] == 'M' || s[i] == 'I' || s[i] == 'P' ) return 0;
            
        return 1;
    }
    return 0;
}

long long HASH(char *s){
    
    int ret = 0,pot;
    int i;
    
    if( isupper(s[0]) && isupper(s[1]) && isupper(s[2]) &&
        isdigit(s[3]) && isdigit(s[4]) && isdigit(s[5]) && isdigit(s[6]) ){
            
        pot = 1;
        for(i=6;i>=3;i--){
            ret += pot*(s[i]-'0');
            pot *= 10;
        }
        
        for(i=2;i>=0;i--){
            ret += pot*(s[i]-'A');
            pot *= 26;
        }
        
        return ret;
    }
    
    ret += OLDL+1;
    pot = 1;
    
    for(i=6;i>=5;i--){
        ret += pot*(s[i]-'0');
        pot *= 10;
    }
    for(i=4;i>=0;i--){
        ret += pot*(val[ s[i]-'A' ] );
        pot *= 21;
    }
    return ret;
}

void process(){
    
    if( !valid(p2) ){
        printf("N\n");
        return ;
    }
    
    int hash1 = HASH(p1);
    int hash2 = HASH(p2);
        
    if( hash2 <= hash1 || hash2 - hash1 > C ){
        printf("N\n");
        return ;
    }
    printf("Y\n");   
}

int main(){
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);
    
    int i,j;
    
    for(i='A',j=0;i<='Z';i++){
        if( i == 'A' || i == 'C' || i == 'M' || i == 'I' || i == 'P' ) continue;
        val[i-'A'] = j++;
    }
    
    OLDL = 0;
    long long pot;
    
    char s[30];
    strcpy(s,"ZZZ9999");
    
    pot = 1;
    for(i=6;i>=3;i--){
        OLDL += pot*(s[i]-'0');
        pot *= 10;
    }
    for(i=2;i>=0;i--){
        OLDL += pot*(s[i]-'A');
        pot *= 26;
    }
    
    while(read())process();

    return 0;
}
