#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>

using namespace std;

int memo[1700000];
pair< int , pair< int , int > > tp[300];
int T;

int cont1[15],cont2[15];

int n;
int hand1[6000],hand2[6000];
int n1,n2;
int c1,c2;

int POTS[15];

int read(){
    scanf("%d",&n);
    if( !n ) return 0;
    int i;
    n1=n2=0;
    
    for(i=0;i<n;i++){
        if(i%2==0) scanf("%d",&hand1[n1++]);
        else scanf("%d",&hand2[n2++]);
    }
    
    return 1; 
}

int rec(int atual){
    if( memo[atual] != -1 ) return memo[atual];
    
    int v[15];
    int i,temp=atual;
    for(i=1;i<=13;i++){
        v[i] = temp%3;
        temp/=3;
    }
    
    int best = 0;
    
    for(i=0;i<T;i++){
        
        int a = tp[i].first;
        int b = tp[i].second.first;
        int c = tp[i].second.second;
        v[a]--; v[b]--; v[c]--;
        
        if( v[a] >=0 && v[b] >=0 && v[c] >=0 ){
            v[a]++; v[b]++; v[c]++;
            
            int dec = POTS[ a ] + POTS[ b ] + POTS[ c ];
            atual -= dec;
            if( atual < 0 ){
                atual++;
                atual--;
            }
            int ret = rec(atual) + 1;
            if( ret > best ) best = ret;
            atual += dec;
        }
        else{
            v[a]++; v[b]++; v[c]++;
        }
    }
    
    return memo[atual] = best;
}

void process(){
    
    c1=c2=0;
    
    memset(cont1,0,sizeof(cont1));
    memset(cont2,0,sizeof(cont2));

    int i,j,val;
    for(i=0;i<n1;i++){
        cont1[ hand1[i] ]++;
        if( cont1[ hand1[i] ] == 3 ){
            cont1[ hand1[i] ] = 0;
            c1++;
        }
    }
    
    for(i=0;i<n2;i++){
        cont2[ hand2[i] ]++;
        if( cont2[ hand2[i] ] == 3 ){
            cont2[ hand2[i] ] = 0;
            c2++;
        }
    }
    
    if( c1 > c2 ){
        printf("1\n");
        return ;
    }
    else if( c1 < c2 ){
        printf("2\n");
        return ;
    }
    
    c1=c2=0;
    
    val = 0;
    int pot = 1;
    for(i=1;i<=13;i++){
        val += pot*(cont1[i]);
        POTS[i] = pot;
        pot *= 3;
    }
    
    
    c1 = rec(val);
    
    val = 0;
    pot = 1;
    for(i=1;i<=13;i++){
        val += pot*(cont2[i]);
        pot *= 3;
    }
    
    c2 = rec(val);   

    printf("%d\n",((c1==c2)?0:((c1>c2)?1:2)));
}

int main(){
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);
    
    int i,j,k;
    T = 0;
    for(i=1;i<=13;i++){
        for(j=i;j<=13;j++){
            for(k=j;k<=13;k++){
                if( i+j > k && i+k > j && j+k > i ){
                    if( i!=j || i!=k || j != k ){
                        tp[T++] = make_pair( i , make_pair(j,k) );
                    }
                }
            }   
        }
    }
    memset(memo,-1,sizeof(memo));
    
    while(read())process();
    return 0;
}
