#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>

using namespace std;

struct state{
    int id;
    int solv;
    int pen;
    int err;
    int res;
};
state user[500];

state test[500],temp[500];

int n,p;
int sol[500];

int read(){
    scanf("%d %d",&n,&p);
    if( n == 0 && p == 0 ) return 0;
    
    int i,j;
    char temp[20];
    
    for(i=0;i<n;i++){
        user[i].id = i;
        
        user[i].solv = 0;
        user[i].pen = 0;
        
        user[i].res = user[i].err = 0;
        
        for(j=0;j<p;j++){
            int er;
            scanf("%d/%s",&er,temp);
        
            if( temp[0] == '-' ){
            }
            else{
                int pp;
                sscanf(temp,"%d",&pp);
                user[i].res += pp;
                
                user[i].err += er;
                user[i].solv++;
                user[i].pen += 20*er + pp;
            }
        }
        sol[i] = user[i].solv;
    }
    
    memcpy(test,user,sizeof(user));
    
    return 1; 
}

int compara(const void *a, const void *b){
    state a1 = *(state *)a;
    state a2 = *(state *)b;
    if( a1.solv == a2.solv ){
        if( a1.pen == a2.pen ) return a1.id - a2.id;
        return a1.pen - a2.pen;
    }
    return a2.solv-a1.solv;
}

pair < int , int > ord[500],ord2[500];

int ok(int P){
    
    memcpy(temp,test,sizeof(test));
    
    int i,j;
    for(i=0;i<n;i++){
        temp[i].solv = sol[i];
        temp[i].pen = P*temp[i].err + temp[i].res;
    }   
    
    qsort(temp,n,sizeof(temp[0]),compara);
       
    
    int ant = 0;
    for(i=0;i<n;i++){
        if( temp[i].solv != temp[ant].solv || temp[i].pen != temp[ant].pen ) ant++;
        ord2[i] = make_pair(temp[i].id,ant);
    }
    
    for(i=0;i<n;i++){
        if( ord[i] != ord2[i] ) return 0;
    }
    return 1;
}

void process(){

    qsort(user,n,sizeof(user[0]),compara);
    int i;
    int ant = 0;
    for(i=0;i<n;i++){
        if( user[i].solv != user[ant].solv || user[i].pen != user[ant].pen ) ant++;
        ord[i] = make_pair(user[i].id,ant);
    }
    
    int ini = 1, fim = 20;
    
    while( fim-ini > 1 ){
        int med = ( ini + fim )/2;
        if( ok(med) ) fim = med;
        else          ini = med+1;
    }
    
    if( !ok(ini) ) ini++;
    
    printf("%d ",ini);
    
    ini = 20;
    fim = 1000000;
    
    while( fim-ini > 1 ){
        int med = ( ini + fim )/2;
        if( ok(med) ) ini = med;
        else          fim = med-1;
    }
    
    if( ok(fim) ) ini = fim;
    
    if( ini >= 1000000 ) printf("*\n");
    else    printf("%d\n",ini);
}

int main(){
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);
    
    while(read())process();
    return 0;
}
