#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#include <ctype.h>
#include <map>
#include <string>
#include <queue>
#include <algorithm>
#include <vector>

using namespace std;

vector < int > adj[51000];
int n,r;

char conj[51000];

long long asum;
int ta,tb;

int read(){
    scanf("%d %d",&n,&r);
    if( n == 0 && r == 0 ) return 0;
    int i,j;
    for(i=1;i<=n;i++) adj[i].clear();
    
    for(i=0;i<r;i++){
        int a,b;
        scanf("%d %d",&a,&b);
        
        adj[a].push_back(b);
        adj[b].push_back(a);  
    }
    
    return 1; 
}

void process(){
    
    int i,j,k;
    
    memset(conj,-1,sizeof(conj));
    ta=tb=0;
    
    asum = 0;
    
    for(i=1;i<=n;i++){
        
        int a=0,b=0;
        long long noa=0;
        int ema,emb;
        
        for(j=0;j<adj[i].size();j++){
            if( conj[ adj[i][j] ] == 0 ){
                noa += adj[i][j];
                a++;
            }
            else if( conj[ adj[i][j]] == 1 ){
                b++;
                emb = adj[i][j];
            }
        }
        
        if( a == ta ){
            conj[i] = 0;
            ta++;
            asum += i;
            continue;
        }
        
        if( b == 0 ){
            conj[i] = 1;
            tb++;
            continue;
        }
        
        if( a == ta-1 ){
            
            ema = asum - noa;
            int ab = 0;
            for(j=0;j<adj[ema].size();j++){
                if( conj[ adj[ema][j] ] == 1 ) break;
            }
            
            if( j == adj[ema].size() ){
                conj[ema] = 1;
                tb++;
                asum -= ema;
                asum += i;
                conj[i] = 0;
                continue;    
            }
 
        }
        
        if( b == 1 ){
            int ba = 0,emba;
            for(j=0;j<adj[emb].size();j++){
                if( conj[ adj[emb][j] ] == 0 ){
                    ba++;
                    emba = adj[emb][j];
                }
            }
            
            if( ba == ta ){
                conj[emb] = 0;
                ta++;
                asum += emb;
                conj[i] = 1;
                continue;
            }
            
            if( tb == 1 && ba == 1 && a == 0 ){
                
                 conj[emba] = 1;
                 asum -= emba;
                 conj[i] = 0;
                 asum += i;
                 
                 for(j=1;j<=n;j++) conj[j] = 1-conj[j]; // executado quase nunca =P
                 swap(ta,tb);
                 asum = (((long long)i)*(i+1))/2 - asum;
                 continue;                 
            }
  
        }
        
        printf("N\n");
        return;
    }
    
    printf("Y\n");
}

int main(){
    freopen("in.txt","r",stdin);
    freopen("out.txt","w",stdout);

    while(read())process();

    return 0;
}
